<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="耗材名称" prop="materialId">
        <el-select v-model="queryParams.materialId" filterable clearable remote reserve-keyword placeholder="请输入耗材名称"
          :remote-method="remoteMethod" :loading="remoteLoading" style="width:300px;">
          <el-option v-for="item in materialList" :key="item.materialId" :label="item.name" :value="item.materialId">
            <span style="float: left">{{ item.name }}</span>
            <span style="float: right; color: #8492a6; font-size: 13px">{{ item.brand }}</span>
            <span style="float: right; color: #8492a6; font-size: 13px">{{ item.series }}</span>
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="发放时间" prop="giveTime">
        <el-date-picker clearable v-model="queryParams.giveTime" type="date" value-format="yyyy-MM-dd"
          placeholder="请选择发放时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="领用人" prop="accepter">
        <el-select v-model="queryParams.accepter" filterable clearable @keyup.enter.native="handleQuery">
          <el-option v-for="item in $store.state.user.userList" :key="item.userId" :label="item.nickName"
            :value="item.userId">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="领用部门" prop="useDept">
        <el-select v-model="queryParams.useDept" filterable clearable @keyup.enter.native="handleQuery">
          <el-option v-for="item in $store.state.user.deptList" :key="item.deptId" :label="item.deptName"
            :value="item.deptId">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['oa:give:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['oa:give:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['oa:give:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
          v-hasPermi="['oa:give:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="materialGiveList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="耗材发放id" align="center" prop="giveId" /> -->
      <!-- <el-table-column label="耗材id" align="center" prop="materialId" /> -->
      <el-table-column label="耗材品牌" align="center" prop="material.brand" />
      <el-table-column label="耗材名称" align="center" prop="material.name" />
      <el-table-column label="规格型号" align="center" prop="material.series" />
      <el-table-column label="发放时间" align="center" prop="giveTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.giveTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="领用人" align="center" prop="acceptUser.nickName" />
      <el-table-column label="领用部门" align="center" prop="dept.deptName" />
      <el-table-column label="领用数量" align="center" prop="giveNum" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['oa:give:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['oa:give:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改cmc耗材发放对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="耗材名称" prop="materialId">
          <el-tag v-if="chooseM.name">{{ chooseMname }}</el-tag>
          <el-button type="primary" @click="materialOpen = true" size="mini">耗材选择</el-button>
        </el-form-item>
        <el-form-item label="发放时间" prop="giveTime">
          <el-date-picker clearable v-model="form.giveTime" type="date" value-format="yyyy-MM-dd" placeholder="请选择发放时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="领用人" prop="accepter">
          <el-select v-model="form.accepter" filterable clearable>
            <el-option v-for="item in $store.state.user.userList" :key="item.userId" :label="item.nickName"
              :value="item.userId">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="领用部门" prop="useDept">
        <el-select v-model="form.useDept" filterable clearable>
          <el-option v-for="item in $store.state.user.deptList" :key="item.deptId" :label="item.deptName"
            :value="item.deptId">
          </el-option>
        </el-select>
        </el-form-item>
        <el-form-item label="领用数量" prop="giveNum">
          <el-input-number :controls="false" v-model="form.giveNum" placeholder="请输入领用数量" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input type="textarea" v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <el-dialog title="选择耗材" :visible.sync="materialOpen" width="60%" append-to-body :close-on-click-modal="false">
      <choose-materal @confirmChoose="confirmMaterial"></choose-materal>
    </el-dialog>
  </div>
</template>

<script>
import { listMaterialGive, getMaterialGive, delMaterialGive, addMaterialGive, updateMaterialGive } from "@/api/oa/material/materialGive";
import { listMaterial, getMaterial } from "@/api/oa/material/material";
import ChooseMateral from './chooseMateral.vue';

export default {
  name: "MaterialGive",
  components: { ChooseMateral },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // cmc耗材发放表格数据
      materialGiveList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 50,
        materialId: null,
        giveTime: null,
        accepter: null,
        useDept: null,
        giveNum: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      remoteLoading: true,
      materialList: [],
      materialOpen: false,
      chooseM: {},
      chooseMname: '',
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询cmc耗材发放列表 */
    getList() {
      this.loading = true;
      listMaterialGive(this.queryParams).then(response => {
        this.materialGiveList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        giveId: null,
        materialId: null,
        giveTime: null,
        accepter: null,
        useDept: null,
        giveNum: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.giveId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.chooseM = {};
      this.title = "新增耗材发放记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.confirmMaterial(row.material)
      const giveId = row.giveId || this.ids
      getMaterialGive(giveId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改耗材发放记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.giveId != null) {
            updateMaterialGive(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addMaterialGive(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const giveIds = row.giveId || this.ids;
      this.$modal.confirm('是否确认删除cmc耗材发放编号为"' + giveIds + '"的数据项？').then(function () {
        return delMaterialGive(giveIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('oa/materialGive/export', {
        ...this.queryParams
      }, `materialGive_${new Date().getTime()}.xlsx`)
    },
    remoteMethod(val) {
      listMaterial({
        pageNum: 1,
        pageSize: 20,
        name: val
      }).then(response => {
        this.materialList = response.rows;
        this.remoteLoading = false;
      });
    },
    confirmMaterial(row) {
      if (row) {
        this.chooseM = row;
        let brand = row.brand
        let name = row.name
        let series = row.series
        if (brand && series) {
          this.chooseMname = name + '-' + brand + '（' + series + '）'
        } else if (brand == null && series != null) {
          this.chooseMname = name + '（' + series + '）'
        } else if (brand != null && series == null) {
          this.chooseMname = name + '-' + brand
        } else {
          this.chooseMname = name
        }
        this.form.materialId = row.materialId;
        this.materialOpen = false;
        if (this.$refs.form)
          this.$refs.form.validateField('materialId')
      }
    },
  }
};
</script>
